/* ARCHIVO: encriptar.c
*  DESCRIPCIN: Contiene la implementacin de un programa que permite
*		encriptar y desencriptar un archivo de acuerdo a la
*		siguiente frmula:
*
*		asciiNuevoCaracter= (asciiCaracterOriginal+5)mod 256
*
*
*  AUTOR: Luis Galrraga Del Prado
*  FECHA DE CREACIN: 19-12-2004
*/

#include <stdio.h>
#include <simpio.h>
#include <conio.h>

void Encriptar(FILE *original,FILE *encriptado);
void Desencriptar(FILE *encriptado,FILE *desencriptado);

void main(){
	string originalname,newname;
	FILE *original, *modificado;
	int op;
	do{
		printf("Ingrese 1 para encriptar, 2 para desencriptar: ");
		op=GetInteger();
	}while(op<1 || op>2);

	if(op==1)
		printf("Ingrese el nombre del archivo a encriptar: ");
	else
		printf("Ingrese el nombre del archivo a desencriptar: ");

	originalname=GetLine();

	if(op==1)
		printf("Ingrese el nombre del archivo encriptado: ");
	else
		printf("Ingrese el nombre del archivo desencriptado: ");

	newname=GetLine();

	original=fopen(originalname,"r");

	if(!original){
		printf("Error al abrir el archivo %s",originalname);
		getch();
		exit(2);
	}

	modificado=fopen(newname,"w");

	if(op==1)
		Encriptar(original,modificado);
	else
		Desencriptar(original,modificado);

	fclose(original);
	fclose(modificado);
}

/* FUNCIN: Encriptar(FILE *original,FILE *encriptado)
*  DESCRIPCIN: Recibe un archivo referenciado por original y retorna
*				su equivalente encriptado el mismo que es referenciado
*				por encriptado.
*/

void Encriptar(FILE *original,FILE *encriptado){
	char c;
	while((c=fgetc(original))!=EOF)
		fputc((c+5)%256,encriptado);

}

/* FUNCIN: Desencriptar(FILE *encriptado,FILE *desencriptado)
*  DESCRIPCIN: Recibe un archivo referenciado por original el mismo que
*				ha sido encriptado y retorna su equivalente desencriptado
*				el mismo que es referenciado por desencriptado.
*/

void Desencriptar(FILE *encriptado,FILE *desencriptado){
	char c;
	/* Como no es posible despejar el caracter original de la frmula, 
	*  aprovecho el hecho de que cualquier caracter cuya suma con 5 da 
	*  menos de 256 no sufrir ningn cambio al aplicarle el mod 256
    */
	while((c=fgetc(encriptado))!=EOF){
		if(c>5)
			fputc(c-5,desencriptado);
		else
			fputc(c+251,desencriptado);


	}
}
