/* ARCHIVO: retrato_robot.c
*  DESCRIPCIN: Contiene la implementacin de un programa que genera el retrato robot de
*		una persona en base a un archivo previo con la codificacin necesaria.
*  AUTOR: Luis Galrraga Del Prado
*  FECHA DE CREACIN: 09-octubre-2005
*/

#include <stdio.h>

void Generar_RetratoRobot(FILE *codigos, FILE *salida);

void main(){
	FILE *infile, *outfile;
	char infilename[256], outfilename[256];
	
	printf("Ingrese el nombre del archivo con los c%cdigos: ",162);
	scanf("%s",infilename);
	
	infile = fopen(infilename,"r");
	if(!infile){
		printf("Error al abrir el archivo %s",infilename);
		getch();
		return;
	}
	
	printf("Ingrese el nombre del archivo de salida: ");
	scanf("%s",outfilename);
	
	outfile = fopen(outfilename,"w");
	if(!outfile){
		printf("Error al abrir el archivo %s",outfilename);
		getch();
		return;
	}

	Generar_RetratoRobot(infile,outfile);
	fclose(infile);
	fclose(outfile);
	getch();
}

/* FUNCIN: Generar_RetratoRobot
*  DESCRIPCIN: Recibe en el archivo referenciado por 'codigos' los cdigos necesarios para construir 
*		un retrato robot, el mismo que es escrito en el archivo de salida.
*/
void Generar_RetratoRobot(FILE *codigos, FILE *salida){
	char caracter, relleno;
	int veces, i;

	while(!feof(codigos)){
		fscanf(codigos,"%d%c%c",&veces,&caracter,&relleno);
		for(i=0;i<veces;i++)
			fputc(caracter,salida);
		if(relleno == '\n')
			fputc('\n',salida);
	}	
}